'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

var shouldLogInConsole = exports.shouldLogInConsole = false;

var delayValues = exports.delayValues = [0.25, 0.5, 1, 2, 5, 10];

var MConstructor = exports.MConstructor = 'constructor';
var MDidMount = exports.MDidMount = 'componentDidMount';
var MShouldUpdate = exports.MShouldUpdate = 'shouldComponentUpdate';
var MRender = exports.MRender = 'render';
var MDidUpdate = exports.MDidUpdate = 'componentDidUpdate';
var MWillUnmount = exports.MWillUnmount = 'componentWillUnmount';
var MSetState = exports.MSetState = 'setState';

var MGetDerivedState = exports.MGetDerivedState = 'static getDerivedStateFromProps';
var MGetSnapshot = exports.MGetSnapshot = 'getSnapshotBeforeUpdate';

var MWillMount = exports.MWillMount = 'componentWillMount';
var MWillReceiveProps = exports.MWillReceiveProps = 'componentWillReceiveProps';
var MWillUpdate = exports.MWillUpdate = 'componentWillUpdate';

var lifecycleMethods = [{ isLegacy: false, isNew: false, name: MConstructor }, { isLegacy: true, isNew: false, name: MWillMount }, { isLegacy: false, isNew: true, name: MGetDerivedState }, { isLegacy: true, isNew: false, name: MWillReceiveProps }, { isLegacy: false, isNew: false, name: MShouldUpdate }, { isLegacy: true, isNew: false, name: MWillUpdate }, { isLegacy: false, isNew: false, name: MRender }, { isLegacy: false, isNew: false, name: MDidMount }, { isLegacy: false, isNew: true, name: MGetSnapshot }, { isLegacy: false, isNew: false, name: MDidUpdate }, { isLegacy: false, isNew: false, name: MWillUnmount }, { isLegacy: false, isNew: false, name: MSetState }];

var lifecycleMethodNames = exports.lifecycleMethodNames = lifecycleMethods.filter(function (mthd) {
  return !mthd.isLegacy;
}).map(function (_ref) {
  var name = _ref.name;
  return name;
});

var lifecycleMethodNamesLegacy = exports.lifecycleMethodNamesLegacy = lifecycleMethods.filter(function (mthd) {
  return !mthd.isNew;
}).map(function (_ref2) {
  var name = _ref2.name;
  return name;
});

var lifecycleMethodNamesNewOnly = exports.lifecycleMethodNamesNewOnly = lifecycleMethods.filter(function (mthd) {
  return mthd.isNew;
}).map(function (_ref3) {
  var name = _ref3.name;
  return name;
});

var lifecycleMethodNamesLegacyOnly = exports.lifecycleMethodNamesLegacyOnly = lifecycleMethods.filter(function (mthd) {
  return mthd.isLegacy;
}).map(function (_ref4) {
  var name = _ref4.name;
  return name;
});

var reduxStoreKey = exports.reduxStoreKey = 'lifecycleVisualizerStore';

var sessionStorageKey = '@@react-lifecycle-visualizer--persistent-state:';
var sessionReplayTimerDelayKey = exports.sessionReplayTimerDelayKey = sessionStorageKey + 'replayTimerDelay';
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(shouldLogInConsole, 'shouldLogInConsole', 'src/constants.js');
  reactHotLoader.register(delayValues, 'delayValues', 'src/constants.js');
  reactHotLoader.register(MConstructor, 'MConstructor', 'src/constants.js');
  reactHotLoader.register(MDidMount, 'MDidMount', 'src/constants.js');
  reactHotLoader.register(MShouldUpdate, 'MShouldUpdate', 'src/constants.js');
  reactHotLoader.register(MRender, 'MRender', 'src/constants.js');
  reactHotLoader.register(MDidUpdate, 'MDidUpdate', 'src/constants.js');
  reactHotLoader.register(MWillUnmount, 'MWillUnmount', 'src/constants.js');
  reactHotLoader.register(MSetState, 'MSetState', 'src/constants.js');
  reactHotLoader.register(MGetDerivedState, 'MGetDerivedState', 'src/constants.js');
  reactHotLoader.register(MGetSnapshot, 'MGetSnapshot', 'src/constants.js');
  reactHotLoader.register(MWillMount, 'MWillMount', 'src/constants.js');
  reactHotLoader.register(MWillReceiveProps, 'MWillReceiveProps', 'src/constants.js');
  reactHotLoader.register(MWillUpdate, 'MWillUpdate', 'src/constants.js');
  reactHotLoader.register(lifecycleMethods, 'lifecycleMethods', 'src/constants.js');
  reactHotLoader.register(lifecycleMethodNames, 'lifecycleMethodNames', 'src/constants.js');
  reactHotLoader.register(lifecycleMethodNamesLegacy, 'lifecycleMethodNamesLegacy', 'src/constants.js');
  reactHotLoader.register(lifecycleMethodNamesNewOnly, 'lifecycleMethodNamesNewOnly', 'src/constants.js');
  reactHotLoader.register(lifecycleMethodNamesLegacyOnly, 'lifecycleMethodNamesLegacyOnly', 'src/constants.js');
  reactHotLoader.register(reduxStoreKey, 'reduxStoreKey', 'src/constants.js');
  reactHotLoader.register(sessionStorageKey, 'sessionStorageKey', 'src/constants.js');
  reactHotLoader.register(sessionReplayTimerDelayKey, 'sessionReplayTimerDelayKey', 'src/constants.js');
  leaveModule(module);
})();

;