'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearInstanceIdCounters = undefined;
var _jsxFileName = 'src/traceLifecycle.jsx';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.default = traceLifecycle;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _constants = require('./constants');

var constants = _interopRequireWildcard(_constants);

var _actionCreators = require('./actionCreators');

var ActionCreators = _interopRequireWildcard(_actionCreators);

var _LifecyclePanel = require('./LifecyclePanel');

var _LifecyclePanel2 = _interopRequireDefault(_LifecyclePanel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

(function () {
  var enterModule = require('react-hot-loader').enterModule;

  enterModule && enterModule(module);
})();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var instanceIdCounters = {};
var traceSym = Symbol('trace'); // for sneaking trace function into the state

var clearInstanceIdCounters = exports.clearInstanceIdCounters = function clearInstanceIdCounters() {
  Object.keys(instanceIdCounters).forEach(function (k) {
    return delete instanceIdCounters[k];
  });
};

var mkInstanceId = function mkInstanceId(componentName) {
  if (!Object.prototype.hasOwnProperty.call(instanceIdCounters, componentName)) {
    instanceIdCounters[componentName] = 0;
  }
  instanceIdCounters[componentName] += 1;
  return instanceIdCounters[componentName];
};

function traceLifecycle(ComponentToTrace) {
  var _class, _temp;

  var superMembers = Object.getOwnPropertyNames(ComponentToTrace.prototype);

  var isLegacy = // component is legacy if it includes one of the legacy methods and no new methods.
  superMembers.some(function (member) {
    return constants.lifecycleMethodNamesLegacyOnly.includes(member);
  }) && superMembers.every(function (member) {
    return !constants.lifecycleMethodNamesNewOnly.includes(member);
  });

  var TracingComponent = (_temp = _class = function (_ComponentToTrace) {
    _inherits(TracingComponent, _ComponentToTrace);

    function TracingComponent(props, context) {
      _classCallCheck(this, TracingComponent);

      var _this = _possibleConstructorReturn(this, (TracingComponent.__proto__ || Object.getPrototypeOf(TracingComponent)).call(this, props, context));

      var instanceId = mkInstanceId(ComponentToTrace.name);

      _this.lifecyclePanel = React.createElement(_LifecyclePanel2.default, {
        componentName: ComponentToTrace.name,
        isLegacy: isLegacy,
        instanceId: instanceId,
        implementedMethods: [].concat(_toConsumableArray(superMembers), _toConsumableArray(ComponentToTrace.getDerivedStateFromProps ? [_constants.MGetDerivedState] : []), [_constants.MSetState]),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 40
        }
      });

      _this.trace = function (methodName) {
        _this.context[constants.reduxStoreKey].dispatch(ActionCreators.trace(ComponentToTrace.name, instanceId, methodName));
      };

      // HACK: need trace in state since static getDerivedStateFromProps can't access instance or context :-(
      if (_this.state) {
        _this.state[traceSym] = _this.trace.bind(_this);
      }
      _this.trace(_constants.MConstructor);
      return _this;
    }

    // Get store from context, to prevent update blocking by `connect`.


    _createClass(TracingComponent, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.trace(_constants.MWillMount);
        if (_get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentWillMount', this)) {
          _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentWillMount', this).call(this);
        }
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.trace(_constants.MDidMount);
        if (_get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentDidMount', this)) {
          _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentDidMount', this).call(this);
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.trace(_constants.MWillUnmount);
        if (_get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentWillUnmount', this)) {
          _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentWillUnmount', this).call(this);
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps() {
        this.trace(_constants.MWillReceiveProps);
        if (_get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentWillReceiveProps', this)) {
          _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentWillReceiveProps', this).apply(this, arguments);
        }
      }
    }, {
      key: 'shouldComponentUpdate',
      value: function shouldComponentUpdate() {
        this.trace(_constants.MShouldUpdate);
        return _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'shouldComponentUpdate', this) ? _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'shouldComponentUpdate', this).apply(this, arguments) : true;
      }
    }, {
      key: 'componentWillUpdate',
      value: function componentWillUpdate() {
        this.trace(_constants.MWillUpdate);
        if (_get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentWillUpdate', this)) {
          _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentWillUpdate', this).apply(this, arguments);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        if (_get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'render', this)) {
          this.trace(_constants.MRender);
          return _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'render', this).call(this);
        }
        return undefined; // no super.render, this will trigger a React error
      }
    }, {
      key: 'getSnapshotBeforeUpdate',
      value: function getSnapshotBeforeUpdate() {
        this.trace(_constants.MGetSnapshot);
        return _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'getSnapshotBeforeUpdate', this) ? _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'getSnapshotBeforeUpdate', this).apply(this, arguments) : null;
      }
    }, {
      key: 'componentDidUpdate',
      value: function componentDidUpdate() {
        this.trace(_constants.MDidUpdate);
        if (_get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentDidUpdate', this)) {
          _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'componentDidUpdate', this).apply(this, arguments);
        }
      }
    }, {
      key: 'setState',
      value: function setState(updater, callback) {
        var _this2 = this,
            _arguments = arguments;

        this.trace(_constants.MSetState);

        // Unlike the lifecycle methods we only trace the update function and callback
        // when they are actually defined.
        var tracingUpdater = typeof updater !== 'function' ? updater : function () {
          _this2.trace(_constants.MSetState + ':update fn');
          return updater.apply(undefined, _arguments);
        };

        var tracingCallback = !callback ? undefined : function () {
          _this2.trace(_constants.MSetState + ':callback');
          callback.apply(undefined, _arguments);
        };
        _get(TracingComponent.prototype.__proto__ || Object.getPrototypeOf(TracingComponent.prototype), 'setState', this).call(this, tracingUpdater, tracingCallback);
      }
    }, {
      key: '__reactstandin__regenerateByEval',
      value: function __reactstandin__regenerateByEval(key, code) {
        this[key] = eval(code);
      }
    }], [{
      key: 'getDerivedStateFromProps',
      value: function getDerivedStateFromProps(nextProps, prevState) {
        if (prevState && prevState[traceSym]) {
          prevState[traceSym](_constants.MGetDerivedState);
        }
        return ComponentToTrace.getDerivedStateFromProps ? ComponentToTrace.getDerivedStateFromProps.apply(ComponentToTrace, arguments) : null;
      }
    }]);

    return TracingComponent;
  }(ComponentToTrace), _class.contextTypes = _defineProperty({}, constants.reduxStoreKey, _propTypes2.default.object), _temp);

  TracingComponent.displayName = 'traceLifecycle(' + (ComponentToTrace.displayName || ComponentToTrace.name || 'Component') + ')';

  // Removing the inappropriate methods is simpler than adding appropriate methods to prototype
  if (isLegacy) {
    delete TracingComponent.getDerivedStateFromProps;
    delete TracingComponent.prototype.getSnapshotBeforeUpdate;
  } else {
    delete TracingComponent.prototype.componentWillMount;
    delete TracingComponent.prototype.componentWillReceiveProps;
    delete TracingComponent.prototype.componentWillUpdate;
  }

  return TracingComponent;
}
;

(function () {
  var reactHotLoader = require('react-hot-loader').default;

  var leaveModule = require('react-hot-loader').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(instanceIdCounters, 'instanceIdCounters', 'src/traceLifecycle.jsx');
  reactHotLoader.register(traceSym, 'traceSym', 'src/traceLifecycle.jsx');
  reactHotLoader.register(clearInstanceIdCounters, 'clearInstanceIdCounters', 'src/traceLifecycle.jsx');
  reactHotLoader.register(mkInstanceId, 'mkInstanceId', 'src/traceLifecycle.jsx');
  reactHotLoader.register(traceLifecycle, 'traceLifecycle', 'src/traceLifecycle.jsx');
  leaveModule(module);
})();

;